//this file is part of eMule
//Copyright (C)2002-2008 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once
#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif
#include "resource.h"
#include "EMF/ReadWriteLock/ReadWriteLock.h"	// SLUGFILLER: SafeHash
#include "EMF/ConChecker/ConChecker.h" //>>> Spike2::ConChecker [eWombat]
#include "EMF/MiniMule\TBHMM.h" //==> dlarge minimule 
#include "EMF/MiniMule\SystemInfo.h" //==> dlarge CPU/MEM 

#define	DEFAULT_NICK		_T("Silver Surfer User") //==> dlarge changed
#define	DEFAULT_TCP_PORT_OLD	4662
#define	DEFAULT_UDP_PORT_OLD	(DEFAULT_TCP_PORT_OLD+10)

#define PORTTESTURL			_T("http://porttest.emule-project.net/connectiontest.php?tcpport=%i&udpport=%i&lang=%i")

class CSearchList;
class CUploadQueue;
class CListenSocket;
class CDownloadQueue;
class CScheduler;
class UploadBandwidthThrottler;
class LastCommonRouteFinder;
class CemuleDlg;
class CClientList;
class CKnownFileList;
class CServerConnect;
class CServerList;
class CSharedFileList;
class CClientCreditsList;
class CModIconMapper; //>>> WiZaRd::ModIconMappings
class CFriendList;
class CClientUDPSocket;
class CIPFilter;
class CWebServer;
class CMMServer;
class CAbstractFile;
class CUpDownClient;
class CPeerCacheFinder;
class CFirewallOpener;
class CUPnPFinder;
class CArgos; //==> dlarge Argos System (Xanatos)
class CIP2Country; //>>> shadow2004::IP2Country [EastShare]
class CPPgBackup; //==> dlarge Backup
class CSystemInfo;  //==> dlarge CPU/MEM

struct SLogItem;

enum AppState{
	APP_STATE_RUNNING = 0,
   	APP_STATE_SHUTTINGDOWN,
	APP_STATE_DONE
};

class CemuleApp : public CWinApp
{

	friend class CTBHMM; //==> dlarge minimule 

public:
	CemuleApp(LPCTSTR lpszAppName = NULL);

//>>> Spike2::ConChecker [eWombat]
	WombatAgent::CConChecker    conchecker;
	void	InitConChecker();
//<<< Spike2::ConChecker [eWombat]

	// ZZ:UploadSpeedSense -->
    UploadBandwidthThrottler* uploadBandwidthThrottler;
    LastCommonRouteFinder* lastCommonRouteFinder;
	// ZZ:UploadSpeedSense <--
	CemuleDlg*			emuledlg;
	CClientList*		clientlist;
	CKnownFileList*		knownfiles;
	CServerConnect*		serverconnect;
	CServerList*		serverlist;	
	CSharedFileList*	sharedfiles;
	CSearchList*		searchlist;
	CListenSocket*		listensocket;
	CUploadQueue*		uploadqueue;
	CDownloadQueue*		downloadqueue;
	CClientCreditsList*	clientcredits;
	CModIconMapper*		theModIconMap; //>>> WiZaRd::ModIconMappings
	CFriendList*		friendlist;
	CClientUDPSocket*	clientudp;
	CIPFilter*			ipfilter;
	CWebServer*			webserver;
	CScheduler*			scheduler;
	CMMServer*			mmserver;
	CPeerCacheFinder*	m_pPeerCache;
	CFirewallOpener*	m_pFirewallOpener;
	CUPnPFinder*		m_pUPnPFinder;
	CIP2Country*		ip2country;  //>>> shadow2004::IP2Country [EastShare]
	CPPgBackup*		ppgbackup; //==> dlarge Backup
	CTBHMM*			minimule; //==> dlarge minimule
	CSystemInfo*		sysinfo; //==> dlarge CPU/MEM 
	CArgos*			argos; //==> dlarge Argos System (Xanatos)

	HANDLE				m_hMutexOneInstance;
	int					m_iDfltImageListColorFlags;
	CFont				m_fontHyperText;
	CFont				m_fontDefaultBold;
	CFont				m_fontSymbol;
	CFont				m_fontLog;
	CFont				m_fontChatEdit;
	CBrush				m_brushBackwardDiagonal;
	static const UINT	m_nVersionMjr;
	static const UINT	m_nVersionMin;
	static const UINT	m_nVersionUpd;
	static const UINT	m_nVersionBld;
	DWORD				m_dwProductVersionMS;
	DWORD				m_dwProductVersionLS;
	CString				m_strCurVersionLong;
	CString				m_strCurVersionLongDbg;
	UINT				m_uCurVersionShort;
	UINT				m_uCurVersionCheck;
	ULONGLONG			m_ullComCtrlVer;
	AppState			m_app_state; // defines application state for shutdown 
	CMutex				hashing_mut;
	CReadWriteLock		m_threadlock;	// SLUGFILLER: SafeHash - This will ensure eMule goes last
	CString*			pstrPendingLink;
	COPYDATASTRUCT		sendstruct;

//==> dlarge remove unused AICH-hashes (Xman)
	volatile bool				m_AICH_Is_synchronizing;
//<== dlarge remove unused AICH-hashes (Xman)
	
// Implementierung
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual BOOL IsIdleMessage(MSG *pMsg);

	// ed2k link functions
//==> dlarge Check already downloaded files (mealla)
	void		AddEd2kLinksToDownload(CString strLinks, int cat, bool askIfAlreadyDownloaded = false);
//<== dlarge Check already downloaded files (mealla)
	void		SearchClipboard();
	void		IgnoreClipboardLinks(CString strLinks) {m_strLastClipboardContents = strLinks;}
//dlarge Smart Category Control 
	/*
	void		PasteClipboard(int cat = 0);
	*/
	void		PasteClipboard(int cat = -1);
//darge end
	bool		IsEd2kFileLinkInClipboard();
	bool		IsEd2kServerLinkInClipboard();
	bool		IsEd2kLinkInClipboard(LPCSTR pszLinkType, int iLinkTypeLen);
	LPCTSTR		GetProfileFile()		{ return m_pszProfileName; }

	CString		CreateED2kSourceLink(const CAbstractFile* f);
//	CString		CreateED2kHostnameSourceLink(const CAbstractFile* f);
	CString		CreateKadSourceLink(const CAbstractFile* f);

	// clipboard (text)
	bool		CopyTextToClipboard(CString strText);
	CString		CopyTextFromClipboard();

	void		OnlineSig();
	void		UpdateReceivedBytes(uint32 bytesToAdd);
	void		UpdateSentBytes(uint32 bytesToAdd, bool sentToFriend = false);
	int			GetFileTypeSystemImageIdx(LPCTSTR pszFilePath, int iLength = -1, bool bNormalsSize = false);
	HIMAGELIST	GetSystemImageList() { return m_hSystemImageList; }
	HIMAGELIST	GetBigSystemImageList() { return m_hBigSystemImageList; }
	CSize		GetSmallSytemIconSize() { return m_sizSmallSystemIcon; }
	CSize		GetBigSytemIconSize() { return m_sizBigSystemIcon; }
	void		CreateBackwardDiagonalBrush();
	void		CreateAllFonts();
	const CString &GetDefaultFontFaceName();
	bool		IsPortchangeAllowed();
	bool		IsConnected();
	bool		IsFirewalled();
	bool		DoCallback( CUpDownClient *client );
	void		SetHighTimer(bool bHigh); //==> dlarge HighTimer (Xanatos)
	uint32		GetID();
	uint32		GetPublicIP(bool bIgnoreKadIP = false) const;	// return current (valid) public IP or 0 if unknown
	void		SetPublicIP(const uint32 dwIP);
	void		ResetStandByIdleTimer();

	// because nearly all icons we are loading are 16x16, the default size is specified as 16 and not as 32 nor LR_DEFAULTSIZE
	HICON		LoadIcon(LPCTSTR lpszResourceName, int cx = 16, int cy = 16, UINT uFlags = LR_DEFAULTCOLOR) const;
	HICON		LoadIcon(UINT nIDResource) const;
	HBITMAP		LoadImage(LPCTSTR lpszResourceName, LPCTSTR pszResourceType) const;
	HBITMAP		LoadImage(UINT nIDResource, LPCTSTR pszResourceType) const;
	void		EnableRTLWindowsLayout();
	void		DisableRTLWindowsLayout();
	void		UpdateDesktopColorDepth();
	void		UpdateLargeIconSize();


    // Elandal:ThreadSafeLogging -->
    // thread safe log calls
	void			HandleLogQueues();

    void			QueueDebugLogLine(bool bAddToStatusBar, LPCTSTR line,...);
    void			QueueDebugLogLineEx(UINT uFlags, LPCTSTR line,...);
//    void			HandleDebugLogQueue();
    void			ClearDebugLogQueue(bool bDebugPendingMsgs = false);

	void			QueueLogLine(bool bAddToStatusBar, LPCTSTR line,...);
    void			QueueLogLineEx(UINT uFlags, LPCTSTR line,...);
//    void			HandleLogQueue();
    void			ClearLogQueue(bool bDebugPendingMsgs = false);

//==> dlarge ModLog
	void			QueueModLogLineEx(UINT uFlags, LPCTSTR line,...);
	void			HandleModLogQueue();
	void			ClearModLogQueue(bool bDebugPendingMsgs = false);
//<== dlarge ModLog
    // Elandal:ThreadSafeLogging <--

	bool			DidWeAutoStart() { return m_bAutoStart; }

protected:
	bool ProcessCommandline();
	void SetTimeOnTransfer();
	static BOOL CALLBACK SearchEmuleWindow(HWND hWnd, LPARAM lParam);

	DECLARE_MESSAGE_MAP()

	HIMAGELIST m_hSystemImageList;
	CMapStringToPtr m_aExtToSysImgIdx;
	CSize m_sizSmallSystemIcon;

	HIMAGELIST m_hBigSystemImageList;
	CMapStringToPtr m_aBigExtToSysImgIdx;
	CSize m_sizBigSystemIcon;

	CString		m_strDefaultFontFaceName;
	bool		m_bGuardClipboardPrompt;
	CString		m_strLastClipboardContents;

    // Elandal:ThreadSafeLogging -->
    // thread safe log calls
    CCriticalSection m_queueLock;
    CTypedPtrList<CPtrList, SLogItem*> m_QueueDebugLog;
    CTypedPtrList<CPtrList, SLogItem*> m_QueueLog;
	CTypedPtrList<CPtrList, SLogItem*> m_QueueModLog; //==> dlarge ModLog
    // Elandal:ThreadSafeLogging <--

	uint32 m_dwPublicIP;
	bool m_bAutoStart;
//>>> Spike2::Winsock2 [eWombat]
protected:
	bool	m_bWinSock2;
public:
	bool	WinSock2() const	{return m_bWinSock2;}
	WSADATA				m_wsaData;
//<<< Spike2::Winsock2 [eWombat]

//==> dlarge lh: lh require obfuscated server connection 
   // When you want to connect to a server obfuscated you need
   // to be able to cryptping, else no server will have a valid Key
	bool IsWaitingForCryptPingConnect();  
//<== dlarge lh: lh require obfuscated server connection 

//>>> Spike2::ConChecker [eWombat]
	UINT	GetConnectionState() const			{return m_nConnectionState;} 
    void	SetConnectionState(const UINT i)	{m_nConnectionState = i;}
private:
	UINT	m_nConnectionState;
//<<< Spike2::ConChecker [eWombat]
    UINT     m_wTimerRes;

//==> dlarge QueuedFlushThreads
public:
	void AddNewDiscAccessThread(CWinThread* threadtoadd);
	void ResumeNextDiscAccessThread();
	void ForeAllDiscAccessThreadsToFinish();
private:
	CTypedPtrList<CPtrList, CWinThread*> threadqueue;
	CCriticalSection					 threadqueuelock;
	uint16								 m_uRunningNonBlockedDiscAccessThreads;
//<== dlarge QueuedFlushThreads

//==> dlarge Modname 
public:
	static const UINT	m_nMVersionMjr;
	static const UINT	m_nMVersionMin;
	static const UINT	m_nMVersionBld;
	static const TCHAR	m_szMVersionLong[];
	static const TCHAR	m_szMVersion[];
	CString		m_strModVersion;
	CString		m_strModLongVersion;
//<== dlarge Modname

//dlarge Design Settings 
public:
	void	CreateExtraFonts(CFont *font);
	void	DestroyExtraFonts();
	CFont *GetBoldFont()		{return &m_ExtraFonts[0];}
	CFont *GetULFont()			{return &m_ExtraFonts[1];}
	CFont *GetItalicFont()		{return &m_ExtraFonts[2];}
	CFont *GetFontByStyle(DWORD nStyle);
protected:
	CFont			m_ExtraFonts[7];
//dlarge end

//==> dlarge Automatic shared files updater 
private:
	static CEvent*				m_directoryWatcherCloseEvent;
	static CEvent*				m_directoryWatcherReloadEvent;
	static CCriticalSection		m_directoryWatcherCS;
	static UINT					CheckDirectoryForChangesThread(LPVOID pParam);
public:
	void ResetDirectoryWatcher();
	void EndDirectoryWatcher();
	void DirectoryWatcherExternalReload();
//<== dlarge Automatic shared files updater 

};

extern CemuleApp theApp;


//////////////////////////////////////////////////////////////////////////////
// CTempIconLoader

class CTempIconLoader
{
public:
	// because nearly all icons we are loading are 16x16, the default size is specified as 16 and not as 32 nor LR_DEFAULTSIZE
	CTempIconLoader(LPCTSTR pszResourceID, const int cx = 16, const int cy = 16, const UINT uFlags = LR_DEFAULTCOLOR);
//	CTempIconLoader(const UINT uResourceID, const int cx = 16, const int cy = 16, const UINT uFlags = LR_DEFAULTCOLOR);
	CTempIconLoader(const UINT uResourceID); //>>> WiZaRd::Cleanup - removed unnecessary parameters
	CTempIconLoader(HANDLE handle); //>>> WiZaRd::FiX for IP2Country and other custom lists [Rapid Mule]
	~CTempIconLoader();

	operator HICON() const{
		return this == NULL ? NULL : m_hIcon;
	}

protected:
	HICON m_hIcon;
};
